(****************************************************************)
(*	Written by D. C. Sessions, 24 April 1987		*)
(****************************************************************)

IMPLEMENTATION MODULE CommandLine;

  FROM	psp		IMPORT	PSPPtr;
  FROM	Strings		IMPORT	Copy;
  			IMPORT	ASCII;

  VAR
    CmdLine				: ARRAY[ 0..127 ] OF CHAR;
    (*	This isn't as simple as its declaration sounds.
	The actual structure is a list of strings, each preceded
	by a length byte.  The end of the list is indicated by a
	zero-length string.						*)

  PROCEDURE ArgV (		index	: CARDINAL;
			VAR	result	: ARRAY OF CHAR	);
    VAR
      j, k				: CARDINAL;

    BEGIN  (*	ArgV	*)
      IF ( index > ArgC ) OR ( index < 1 )
	THEN result[ 0 ] := ASCII.nul;	(* Idiots get no results	*)
	ELSE
	  j := 0;
	  FOR k := 2 TO index DO
	    j := j + ORD( CmdLine[ j ] ) + 1;
	    END;
	  Copy( CmdLine, j + 1, ORD( CmdLine[ j ] ), result );
	  END;
      END	ArgV;

  PROCEDURE BuildCmdLine;

    PROCEDURE FindNext(	inx		: CARDINAL;
			tops		: CARDINAL;
			mark		: CHAR;
			it		: ARRAY OF CHAR )	: CARDINAL;
	(*  Starting at 'inx', find next 'mark' in 'it', not past 'tops'.
	    Return number of characters scanned, not including 'mark'.	*)

      VAR
	ptr				: CARDINAL;

      BEGIN	(* FindNext *)
	ptr := inx;
	WHILE ( ( ptr <= tops ) AND ( it[ ptr ] # mark )
	    AND ( ( it[ ptr ] # ASCII.ht ) OR ( mark # ' ' ) ) ) DO
	  IF ( ( it[ ptr ] = '"' ) OR ( it[ ptr ] = "'" ) )
	    THEN INC( ptr, 2 + FindNext( ptr + 1, tops, it[ ptr ], it ) );
	    ELSE INC( ptr );
	    END;	(* IF *)
	  END;	(* WHILE *)
	RETURN ptr - inx;
	END	FindNext;

    VAR
      src				: ARRAY [ 0..127 ] OF CHAR;
      si, di				: CARDINAL;
      MaxIndex				: CARDINAL;
      j, n				: CARDINAL;

    BEGIN	(* BuildCmdLine *)
      ArgC := 0;
      WITH PSPPtr^ DO
	MaxIndex := ORD( CommandTailLength );
	WHILE ( MaxIndex > 0 )
	  AND ( ( CommandTail[ MaxIndex ] = ' ' )
	    OR  ( CommandTail[ MaxIndex ] = ASCII.cr )
	    OR  ( CommandTail[ MaxIndex ] = ASCII.ht ) )
	  DO
	    DEC( MaxIndex );
	    END; (* WHILE *)
	FOR si := 1 TO MaxIndex DO
	  src[ si ] := CommandTail[ si ];
	  END;
	END;
      si := 1;
      di := 0;
      WHILE si <= MaxIndex DO
	WHILE ( si <= MaxIndex )	(* Skip whitespace *)
	  AND ( ( src[ si ] = ' ' )
		OR ( src[ si ] = ASCII.ht ) ) DO INC( si ) END;
	n := FindNext( si, MaxIndex, ' ', src );
	IF si + n > MaxIndex THEN n := MaxIndex +1 - si END;
	CmdLine[ di ] := CHR( n );		(* Insert String Length *)
	INC( di );
	IF n > 0 THEN INC( ArgC ) END;
	FOR j := 1 TO n DO
	  CmdLine[ di ] := src[ si ];
	  INC( di );
	  INC( si );
	  END;
	END;
      END	BuildCmdLine;

  BEGIN	(* CommandLine *)
    BuildCmdLine;
    END CommandLine.
